(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Arial", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Arial", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Arial", 14, L0, center, nohscroll, bold;
	fontset = section, "Arial", 14, L0, bold, grayBox;
	fontset = subsection, "Arial", 12, L0, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L0, bold, whiteBox;
	fontset = text, "Arial", 12, L0;
	fontset = smalltext, "Arial", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65280;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Arial", 10, L0, nohscroll, italic, B65280;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Arial", 10, L0, nohscroll;
	fontset = clipboard, "Arial", 12, L0, nohscroll;
	fontset = completions, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Arial", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Arial", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; initialization; nohscroll; center; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 24; ]
*)
Local Approximation Study
of Scalar Difference Schemes
Involving one Spatial Variable 
(*
:[font = name; inactive; initialization; nohscroll; ]
*)
                             Victor G. Ganzha and Evgenii V. Vorozhtsov
(*
:[font = section; inactive; initialization; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 14; ]
*)
Impressum
(*
:[font = clipboard; inactive; initialization; nohscroll; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Arial"; fontSize = 12; ]
*)
This Mathematica-Notebook is part of the book entitled
                                     V.G.Ganzha and E.V.Vorozhtsov
  Numerical Solutions For Partial Differential Equations: Problem Solving
  Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.
(*
:[font = subsection; inactive; initialization; ]
*)
Copyright
(*
:[font = text; inactive; ]
  Numerical Solutions For Partial Differential Equations: Problem Solving
  Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = section; inactive; ]
General Description

:[font = text; inactive; ]

   The program appr1.ma which follows below enables one to determine the
approximation order of scalar difference schemes approximating the scalar 
PDE of the form (2.5.1). The details of the corresponding algorithm are dicus-
sed in Section 2.5 of the above book. The algorithm is based on the substitution 
of Taylor expansions of grid functions into a specific difference scheme.

:[font = section; inactive; ]
User's Guide
:[font = subsection; inactive; ]
Step 1.
:[font = special4; inactive; nowordwrap; nohscroll; ]
   Specify the form of a differential equation by modifying the body of the
 function eqn[   ]. Compile the input PDE.

:[font = subsection; inactive; ]
Step 2.
:[font = special4; inactive; nowordwrap; nohscroll; ]

    Specify the form of a difference scheme by modifying the body of the function
sch1 or sch2, see below Section "Examples of Difference Schemes".
Load and compile the difference scheme.
:[font = subsection; inactive; ]
Step 3.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Load and compile the program beginning with the line

:[font = input; nowordwrap; ]
               ClearAll[appr1];


:[font = subsection; inactive; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 12; ]
Step 4.
:[font = special4; inactive; nowordwrap; nohscroll; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Arial"; fontSize = 12; ]
 Specify the input data by  entering them in the line
:[font = input; nowordwrap; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]

             appr1[3, eqn, sch1]

:[font = special4; inactive; nowordwrap; nohscroll; ]
      Then click in this line and wait for the result of  symbolic computation. The
 meaning of the input parameters is explained in Section "Parameters Used in
 Program appr1.ma".

:[font = section; inactive; ]
Program Listing

:[font = input; initialization; nowordwrap; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]
*)

ClearAll[appr1];
appr1[kt_, eq_, sc_] := Module[
{eq1},

ClearAll[u, ss, eq1, sc1, sc2, dcs];
    u[k_, m_]:= Block[{x, t, ss},
                                  ss = v[x, t];
 Do[
             Do[ i2=ktj - i1;
      dr1 = If[i1==0, 1, (k*h - xc)^i1];
      dr2 = If[i2==0, 1, (m*dt - tc)^i2];
      dr = dr1*dr2/(i1!*i2!);
     ss = ss + Derivative[i1, i2][v][x, t]*dr,
                  {i1, 0, ktj}],
        {ktj, kt}];
    ss ];

(* -- Specification of the x- and t-coordinates of 
      the center of the Taylor series expansion - *)
      centexp = {xc -> j*h, tc -> n*dt};
eq1 = eq;
   pv = Derivative[0, 1][v][x, t] - eq1;
Print["The right-hand side of the differential"];
Print["equation (2.5.1)"];   
        Print[pv];
(* -- Determining mx, the highest order of the 
     x-derivative in the original partial 
     differential equation ----------------- *)
 Do[k1 = 20- k + 1;
    mk = Exponent[pv, Derivative[k, 0][v][x, t]];
 If[mk==0, Goto[endloop], mx = k; Break[ ]];
 Label[endloop],
		{k, 20}];
Print["The highest order of x-derivative in PDE", 
      " is ", mx];
 OutputForm[pv] >> ap.m;
 (* -- Initialization of the table dcs for the 
       differential consequences of the 
       differential equation ------------- *)
    dcs = {}; ktp = kt + 1;
    indcs = Table[99, {i, 1, ktp}, {k, 1, kt}];
 (* -- Symbolic computation of dcs[[i,j]] 
       for 2<=i+j<=kt -------------------- *)
 ind = 1; indcs[[1, 1]] = ind; AppendTo[dcs, pv];
 ind = 2; indcs[[2, 1]] = ind; 
 sc2 = D[pv, x]; AppendTo[dcs, sc2];
 Print["The differential consequences"];
       Print[dcs];
 Do[
    Do[ nxj = ktj - ntj;
               If[nxj==1&&ntj==1, Goto[endloop]];
 If[ntj==1, Goto[ntj1]];
    k1 = mx*ntj;
 k2 = indcs[[nxj+1,ntj-1]]; vtt = D[dcs[[k2]], t];
       Do[
 vtt = vtt /. Derivative[k, 1][v][x, t] ->
               D[dcs[[1]], {x, k}],
      {k, k1}];
Goto[ready];
Label[ntj1]; k= indcs[[nxj, ntj]]; 
                 vtt = D[dcs[[k]], x];
Label[ready]; ind = ind + 1; 
              indcs[[nxj+1, ntj]] = ind;
                AppendTo[dcs, vtt];
OutputForm[nxj] >>> ap.m;
OutputForm[ntj] >>> ap.m;
OutputForm[vtt] >>> ap.m;
Label[endloop],
                  {ntj, ktj}],
    {ktj, 2, kt}];
(* -- Substitution of the differential 
    consequences into the modified equation -- *)
       sc1 = sc /. centexp;
                            sc1 = Simplify[sc1];
  Print["The left-hand side of the differential"];
  Print["approximation equation fda = 0"];   

OutputForm[sc1] >>> ap.m;
      Print[sc1]; sc2 = Expand[sc1];
      r1v = sc2 - eq1;
  Do[ Do[ nxj = ktj - ntj; k = indcs[[nxj+1, ntj]];
 r1v = 
 r1v /. Derivative[nxj, ntj][v][x, t] -> dcs[[k]],
                 {ntj, ktj}],
       {ktj, kt}];
 r1v = r1v /. Derivative[0, 1][v][x, t] -> pv;
   r1v = Expand[r1v]; r1v = Simplify[r1v];
   sc2 = eq1 + r1v;
Print["The left-hand side of the differential"];
  Print["approximation equation fda = 0 after "];
Print["the substitution of differential", 
      " consequences"];
                   Print[sc2];
 OutputForm[sc2] >>> ap.m;
                   r1v = Expand[r1v];
Print["The expression for the leading terms of"];
Print["the truncation error of difference scheme"];
  Print[r1v];
  If[r1v===0,
Print["The modified equation of scheme coincides",
     " with the original PDE at kt = ",kt, "."];
  k1 = kt +1;
Print["Please take the value kt = ",k1," and", 
      "repeat the computation with this new",
      " value of kt."]; Interrupt[ ]];
 (* -- Determination of the local approximation
       order of the difference scheme ------- *)
 k1 = mx*kt; ntx = 0;
 Do[ ak = Coefficient[r1v, h, k];
  If[ak===0, Goto[nextk]]; nxord = k;
 ntx= Exponent[ak, dt]; If[ntx > 0, Goto[nextk]];
	      Break[ ];
Label[nextk],
     {k, k1}];
  ntx = 0;
 Do[ ak = Coefficient[r1v, dt, k];
  If[ak===0, Goto[nextk]]; ntord = k;
 ntx= Exponent[ak,h]; If[ntx > 0, Goto[nextk]];
 Break[ ];
           Label[nextk],
     {k, k1}];
Print["The approximation order of scheme is O(h^",
        nxord, ") + O(dt^", ntord, ")"];
 napmax = Max[nxord, ntord];
     If[napmax > 1,
  Do[ak = Coefficient[r1v, dt, k];
    If[ak=!=0, ntx1 = k; ntx2 = 0;
     Do[bj = Coefficient[ak, h, j];
      If[bj=!=0, ntx2 = j; Break[ ]],
     {j, napmax}]];
     If[ntx2!=0&&ntx1 + ntx2 == napmax,
  Print["+ O(dt^", ntx1, "*h^", ntx2, ")"]],
 {k, napmax}]];
(* ----- End of the module ------ *)
   ClearAll[u, ss, eq1, sc1, sc2, dcs]; ];

(*
:[font = section; inactive; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 14; ]
Example of Differential Equation

:[font = input; nowordwrap; ]
   eqn = D[v[x,t],t]+a*D[v[x,t],x]

:[font = section; inactive; ]
Examples of Difference Schemes

:[font = subsection; inactive; ]
 The upwind difference scheme for advection equation (2.1.1)

:[font = input; nowordwrap; ]

sch1 = (u[j,n+1] - u[j,n])/dt + 
             a*(u[j,n] - u[j - 1,n])/h   
          
:[font = subsection; inactive; ]
 The Lax-Wendroff scheme for advection equation (2.1.1)
:[font = input; nowordwrap; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]

sch2 =
       ( ut1 = (u[j, n+1] - u[j,n])/dt + 
                 a*(u[j+1,n] - u[j-1,n])/(2*h);
uxx = dt*a^2*(u[j+1,n]-2*u[j,n]+u[j-1,n])/(2*h^2); 
  ut1 - uxx )
:[font = subsection; inactive; ]
The Crank-Nicolson scheme for equation (2.1.1) 
:[font = input; nowordwrap; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]

sch3 = ( ut1 = (u[j, n+1] - u[j,n])/dt;  
      ux1 = a*(u[j+1,n+1] -u[j-1,n+1] +
               u[j+1,n] - u[j-1,n])/(4*h);
      ut1 + ux1  )  
(* ----------- dt is the time step ------------ *)

:[font = section; inactive; initialization; ]
*)
Parameters Used in Program appr1.ma

(*
:[font = text; inactive; initialization; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Arial"; fontSize = 12; ]
*)
__________________________________________________________
 Parameter                                     Description
__________________________________________________________
 kt                              order of expansion into the Taylor series, kt > 1
eq                              the left-hand side of the differential equation eq = 0
sc                              the left-hand side of the difference equation sc = 0
__________________________________________________________
(*
:[font = section; inactive; ]
Examples of the Input Data
:[font = subsubsection; inactive; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 10; ]
Example 1
:[font = input; nowordwrap; ]
             appr1[2, eqn, sch1]   
:[font = subsubsection; inactive; ]
Example 2
:[font = input; nowordwrap; ]

             appr1[3, eqn, sch2]
:[font = subsubsection; inactive; ]
Example 3
:[font = input; nowordwrap; ]

             appr1[3, eqn, sch3]
:[font = section; inactive; ]
The structure of the Output

:[font = special4; inactive; nowordwrap; nohscroll; ]

The following data are printed out in the process
of the work of the program:

1. The right-hand side of the specific differential equation of the form (2.5.1);

2. The positive integer representing the highest order of x-derivative in PDE; 

3. The differential consequences of the original  PDE involving the derivatives
     up to the user-specified order kt;

4. The left-hand side of the differential approximation equation fda = 0;

5. The left-hand side of the differential approximation equation fda = 0 after
     the substitution of differential consequences;

6. The expression for the leading terms of the truncation error of difference scheme;


7. The approximation order of difference scheme.

^*)